sub header(  )
{
	my ($title) = @_;

	print OUT "<!DOCTYPE HTML  PUBLIC \"-//IEFT/DTD HTML 2.0//EN\">\n";
	print OUT "<html>\n";
	print OUT "<head>\n";
	print OUT "<title>EPOC32: $title</title>\n";
	print OUT "<script language=\"javascript\">\n";
	print OUT "<!-- Beginning of javascript Applet -------\n";
	print OUT "function showHiResPicture(gifName) {\n";
	print OUT "window.open(gifName,'HIRESGIF','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=360,height=225');\n";
	print OUT "}\n";
	print OUT "// -- End of javascript code -------------- -->\n";
	print OUT "</script>\n";
	print OUT "</head>\n";
	print OUT "<body background=\"../group/sdk-background.jpg\">\n";
	print OUT "<table cellpadding=0 cellspacing=0 boarder=0>\n";
	print OUT "<tr>\n";
	print OUT "<td bgcolor=#000000 width=490 height=40><img align=top border=0 src=\"../group/bottom-bar-left.gif\" alt=\"EPOC logo\" hspace=0></td>\n";
	print OUT "</tr>\n";
	print OUT "</table>\n";
	print OUT "<h1><a name=\"stdlib.$title\"></a>$title</h1>\n";
	print OUT "<hr size=5>\n";
}

sub trailer()
{
	print OUT "<hr>\n";
	print OUT "<table cellpadding=0 cellspacing=0 boarder=0>\n";
	print OUT "<tr>\n";
	print OUT "<td bgcolor=#000000 width=490 height=40><img align=top border=0 src=\"../group/bottom-bar-left.gif\" alt=\"EPOC logo\" hspace=0></td>\n";
	print OUT "</tr>\n";
	print OUT "</table>\n";
	print OUT "</body>\n";
	print OUT "</html>\n";
}

sub process( $ )
{
	my ($pattern) = @_;

print "pattern is $pattern\n";

print "glob is ",glob($pattern),"\n";

	foreach $file (glob ($pattern))
	{
print "file is $file\n";
		next if ($file =~ /sys\/reent.h/i);
		open FILE, "<$file" || die "Cannot open '$file'\n";
		$files{$file} = $file;

		while (<FILE>)
		{
			next if (/^#/);

			if (/^IMPORT_C\s+(.*\W)(\w+)\s*\((.*)\)/)
			{
				$implemented{$2} = $file;
				$rettype{$2} = $1;
				$status{$2} = "&nbsp;";
				$param{$2} = $3;
				next;
			}
			if (/^(\w+.*)\W(\w+.*)\s*\((.*)\)/)
			{
				$implemented{$2} = $file;
				$rettype{$2} = $1;
				$status{$2} = "<font color=#FF0000>not implemented</font>";
				$param{$2} = $3;
				next;
			}
		}

		close FILE;
	}
print "end of for\n";
}

chdir ("/epoc32/include/libc") || die "unable to chdir to /epoc32/include/libc\n";;
&process("*.h");
foreach $path (glob("*"))
{
	&process("$path/*.h") if (-d $path);
}

foreach $file (keys %files)
{
	my ($count) = 0;
	foreach $func (sort keys %implemented)
	{
		next if ($implemented{$func} ne $file);
		$count++;
	}
	undef $files{$file} if ($count == 0);
}

chdir ("/epoc32/doc/stdlib") || die "unable to chdir to /epoc32/doc/stdlib\n";

open OUT, ">slfuncs.htm" || die "unable to open slfuncs.htm\n";
&header("EPOC32 Stdlib functions");

print OUT "<table border=2>\n";
print OUT "<tr align=left valign=top>\n";
print OUT "<td width=20%>\n";
print OUT "<b>Function</b>\n";
print OUT "</td>\n";
print OUT "<td width=50%>\n";
print OUT "<b>Prototype</b>\n";
print OUT "</td>\n";
print OUT "<td width=10%>\n";
print OUT "<b>File</b>\n";
print OUT "</td>\n";
print OUT "<td width=20%>\n";
print OUT "<b>Status</b>\n";
print OUT "</td>\n";
print OUT "</tr>\n";
foreach $func (sort keys %implemented)
{
	next if ($func =~ /^_/);
	$rettype{$func} =~ s/^extern\s+//;
	$implemented{$func} =~ tr/A-Z/a-z/;
	$implemented{$func} =~ s/sys\/unistd.h/unistd.h/;
	$implemented{$func} =~ s/sys\/dirent.h/dirent.h/;
	print OUT "<tr align=left valign=top>\n";
	print OUT "<td width=20%>\n";
	print OUT "<p>$func</p>\n";
	print OUT "</td>\n";
	print OUT "<td width=50%>\n";
	print OUT "<p>$rettype{$func} $func ($param{$func});</p>\n";
	print OUT "</td>\n";
	print OUT "<td width=10%>\n";
	print OUT "<p>$implemented{$func}</p>\n";
	print OUT "</td>\n";
	print OUT "<td width=20%>\n";
	print OUT "<p>$status{$func}<p>\n";
	print OUT "</td>\n";
	print OUT "</tr>\n";
}
print OUT "</table>\n";
&trailer();
close OUT;
